# defined
Cheks if properties or variables are defined


```bash
$>  npm i -s array.defined
```

## Usage

```typescript
// import defined or polyfill into your src
import { definedList } from "array.defined";

[1,2, null, undefined].defined() // => [1,2]
defined(null) // => false
defined(undefined) // => false
definedList([1,2]) // => [1,2]
definedList([undefined, null]) // => []

// filter first
[1,2,3].first()  // => [1]
// filter last
[1,2,3].last()  // => [3]
```

### Template for wrapping immutable lists

```typescript
import { Iterable, List } from "immutable";
import { defined } from "array.defined";

Iterable.prototype.defined = defined(Iterable.prototype.defined)
  ? Iterable.prototype.defined
  : function (this: any) {
      return this.toList().filter((e: any) => defined(e));
    };

Iterable.prototype.allDefined = defined(Iterable.prototype.allDefined)
  ? Iterable.prototype.allDefined
  : function (this: any) {
      return this.toList().every((e: any) => defined(e)) ? this : List();
    };


```
## Publish

```bash
npm version [<newversion> | major | minor | patch | premajor | preminor | prepatch | prerelease]
git push --follow-tags
npm publish
```
